///////////////////////////////////////////////////////////////////////////////
// ControllerMain.cpp
// ==================
// Derived Controller class for main window
//
//  AUTHOR: Song Ho Ahn (song.ahn@gmail.com)
// CREATED: 2006-07-09
// UPDATED: 2006-07-09
//
//	EXTENSION:
//	AUTHOR: Lukas Chripko (luxas98@gmail.com)
//  UPDATED: 2011-05-23
///////////////////////////////////////////////////////////////////////////////


#include <windows.h>
#include <commctrl.h>                   // common controls
#include "ControllerMain.h"
#include "resource.h"
#include "Window.h"
using namespace Win;


bool CALLBACK enumerateChildren(HWND childHandle, LPARAM lParam);

ControllerMain::ControllerMain(ModelGL *model, ControllerGL* glCtrl, ControllerFormGL* formCtrl): model(model),glCtrl(glCtrl),formCtrl(formCtrl){}

int ControllerMain::command(int id, int cmd, LPARAM msg)
{
    switch(id)
    {
		case ID_FILE_EXIT:
			::PostMessage(handle, WM_CLOSE, 0, 0);
			break;
		case ID_FILE_OPENFILE:
		//model->opened = false;
		//System::Windows::Forms::MessageBox::Show("tarama");
		//::PostMessage(handle, WM_OPENFILE, 0, 0);
		//::DefWindowProc(handle, WM_OPENFILE,0,msg);
			glCtrl->loadFile();
			formCtrl->loadFile();
		//model->loadFile();
			break; 
    }

    return 0;
}



int ControllerMain::close()
{
    // close all child windows first
    ::EnumChildWindows(handle, (WNDENUMPROC)enumerateChildren, (LPARAM)WM_CLOSE);

    ::DestroyWindow(handle);                    // close itself
    return 0;
}



int ControllerMain::create()
{
    return 0;
}



int ControllerMain::size(int w, int h, WPARAM wParam)
{
    // pass it to status bar
    HWND statusHandle = ::GetDlgItem(handle, IDC_STATUSBAR);
    ::SendMessage(statusHandle, WM_SIZE, 0, 0);     // automatically resize width, so send 0s
    ::InvalidateRect(statusHandle, 0, FALSE);       // force to repaint

    return 0;
}




///////////////////////////////////////////////////////////////////////////////
// enumerate all child windows
///////////////////////////////////////////////////////////////////////////////
bool CALLBACK enumerateChildren(HWND handle, LPARAM lParam)
{
    if(lParam == WM_CLOSE)
    {
        ::SendMessage(handle, WM_CLOSE, 0, 0);  // close child windows
    }

    return true;
}
int ControllerMain::resize(int x, int y){
	RECT rect;
	RECT status_bar_rect;
	::GetWindowRect(getHandle(),&rect);
	HWND statusHandle = ::GetDlgItem(handle, IDC_STATUSBAR);
	::GetWindowRect(statusHandle,&status_bar_rect);
	::SetWindowPos(statusHandle,0,0,rect.bottom - rect.top,0,50,SWP_NOZORDER); 
	formCtrl->resize(rect.right - rect.left - 300 , rect.bottom-rect.top - 80);
	glCtrl->resize(rect.right - rect.left - 300,rect.bottom - rect.top - 80);
	//::SetWindowPos(getHandle(),0,0,0,100,100, SWP_NOZORDER);
	//System::Windows::Forms::MessageBox::Show("RESIZE CtrlMain");
	return 0;
}
