///////////////////////////////////////////////////////////////////////////////
// ControllerMain.h
// ================
// Derived Controller class for main window
//
//  AUTHOR: Song Ho Ahn (song.ahn@gmail.com)
// CREATED: 2006-07-09
// UPDATED: 2006-07-09
//
//	EXTENSION:
//	AUTHOR: Lukas Chripko (luxas98@gmail.com)
//  UPDATED: 2011-05-23
///////////////////////////////////////////////////////////////////////////////

#ifndef WIN_CONTROLLER_MAIN_H
#define WIN_CONTROLLER_MAIN_H


#include "Controller.h"
#include "ModelGL.h"
#include "ControllerGL.h"
#include "ControllerFormGL.h"

namespace Win
{
    class ControllerMain :public Controller
    {
    public:
		//ControllerMain(){};
		ControllerMain(ModelGL *model, ControllerGL *glCtrl, ControllerFormGL *formCtrl);
        ~ControllerMain() {};

        int command(int id, int cmd, LPARAM msg);   // for WM_COMMAND
        int close();
        int create();                               // for WM_CRERATE
        int size(int w, int h, WPARAM wParam);      // for WM_SIZE: width, height, type(SIZE_MAXIMIZED...)
		int resize(int x, int y);

    private:
		ModelGL* model;
		ControllerGL* glCtrl;		// add for loadFile acces from menu
		ControllerFormGL* formCtrl;
        //Win::View  view;

    };
}

#endif
