/**************************************************************************************************/
//	permute()
//	
//	Template function for permuting an array of n elements.  Works with any 
//	builtin data type or class for which the assignment operator is overloaded.
//	Maintains a lexicographic (dictionary-type) ordering based on the order in the
//	initial array.
//	
//	Arguments:
//			array - an array of builtin datatypes or objects
//			start - the initial point at which to start the permutation (allows for
//					the permutation of the last X elements of the array, and not 
//					just all of the elements).
//			n -		the total number of elements in the array
//	
//	Example call:
//	char array[]="bar";
//	permute(array,0,3);
//
//		output:
//				b a r 
//				b r a 
//				a b r 
//				a r b 
//				r b a 
//				r a b 
//	
//	Reinterpretted, simplified, and templatized version of an algorithm from :
//	Flamig, B. 1995.  Practical Algorithms in C++.

#include <iostream>

template <typename T>
