///////////////////////////////////////////////////////////////////////////////
// ViewFormGL.cpp
// ==============
// View component of OpenGL dialog window
//
//  AUTHORL Song Ho Ahn (song.ahn@gmail.com)
// CREATED: 2006-07-10
// UPDATED: 2006-08-15
//
//	EXTENSION:
//	AUTHOR: Lukas Chripko (luxas98@gmail.com)
//  UPDATED: 2011-05-23
///////////////////////////////////////////////////////////////////////////////

#include "ViewFormGL.h"
#include "resource.h"
#include "Log.h"
#include <msclr\marshal.h> // Library for pasring System::String to diff types
using namespace Win;
using namespace msclr::interop;
//using namespace mslcr::interop;

///////////////////////////////////////////////////////////////////////////////
// default ctor
///////////////////////////////////////////////////////////////////////////////
ViewFormGL::ViewFormGL()
{
}


///////////////////////////////////////////////////////////////////////////////
// default dtor
///////////////////////////////////////////////////////////////////////////////
ViewFormGL::~ViewFormGL()
{
}



///////////////////////////////////////////////////////////////////////////////
// initialize all controls
///////////////////////////////////////////////////////////////////////////////
void ViewFormGL::initControls(HWND handle)
{
    // set all controls
	recordList.set(handle,IDC_RECORDLIST);
    trackbarRed.set(handle, IDC_RED);
    trackbarGreen.set(handle, IDC_GREEN);
    trackbarBlue.set(handle, IDC_BLUE);
	trackbarBlend.set(handle, IDC_BLEND);
	trackbarThreshold.set(handle, IDC_THRESHOLD);
    // initial state
    trackbarRed.setRange(0, 255);
    trackbarRed.setPos(0);
    trackbarGreen.setRange(0, 255);
    trackbarGreen.setPos(0);
    trackbarBlue.setRange(0, 255);
    trackbarBlue.setPos(0);
	trackbarBlend.setRange(0 , 100);
	trackbarBlend.setPos(0);
	trackbarThreshold.setRange(0,1000);
	trackbarThreshold.setPos(0);

	recordList.hide();
}


///////////////////////////////////////////////////////////////////////////////
// update trackbars
///////////////////////////////////////////////////////////////////////////////
void ViewFormGL::updateTrackbars(HWND handle, int position)
{
    if(handle == trackbarRed.getHandle())
    {
        trackbarRed.setPos(position);
    }
    else if(handle == trackbarGreen.getHandle())
    {
        trackbarGreen.setPos(position);
    }
    else if(handle == trackbarBlue.getHandle())
    {
        trackbarBlue.setPos(position);
	} else if(handle == trackbarBlend.getHandle()){
		trackbarBlend.setPos(position);
	}
}
void ViewFormGL::resetRecordList(){
	int test = recordList.getCount();
	int i = 0;
	while(i != test){
		recordList.deleteString(0);
		i++;
	}
}
void ViewFormGL::addRecordList(System::String^ s){
	//recordList.addString(s->toS);
	int record_number = recordList.getCount();
	System::String^ infoString = gcnew System::String("Record " + record_number.ToString() + ": ");
	marshal_context^ context = gcnew marshal_context();
	const wchar_t* record;
	s = s->Concat(infoString,s);
	record = context->marshal_as<const wchar_t*>(s);
	//delete context;
	recordList.addString(record);
}
